<script setup lang="ts">
import { onMounted, ref } from "vue";
import type Table from "@/types/ListTable";
import { useTableStore } from "@/stores/table";
import VueQrcode from 'vue-qrcode';
import axios from "@/services/axios";
const tableStore = useTableStore();
const drawer = ref(false);
const drawerg = ref(false);
const drawery = ref(false);
const show = ref(false);
const showConfirm = ref(false);
const showQR = ref(false);


function getOrderbyTable(table: Table) {
  tableStore.getOrderByTable(table.id!);
}

// async function getNextQRCode() {
//       const response = await axios.get('/orders/next-qrcode');
//       const { url } = response.data;
//       currentOrder.value++;
//       generateQRCode(currentOrder.value);
//       window.location.href = url;
//     };

function Open() {
  tableStore.changeStatusTable()
  drawerg.value = false;
};

const Change = (tables: Table) => {
  tableStore.changeTable(tables);
  showConfirm.value = true;

};

const confirmChangeTable = () => {
  tableStore.confirmChange();
  // tableStore.ItemChangeTable.id = 0;
  drawer.value = false;
  showConfirm.value = false;

};
onMounted(async () => {
  await tableStore.getTable();
});
const Add = (tables: Table) => {
  if (tables.status == "green") {
    tableStore.Additem(tables);
    drawerg.value = true;
  } else if (tables.status == "red") {
    tableStore.ItemChangeTable.id = 0;
    tableStore.showTableName(tables);
    getOrderbyTable(tables);
    showQR.value = true;
    drawer.value = true;
  } else {
    tableStore.Additem(tables);
    drawery.value = true;
  }
  tableStore.dialog = false;
};

const AredItemsCount = () => {
  const AredItems = tableStore.tables.filter(
    (item) => item.status === "red" && item.type === "A"
  );
  const AredItemsCount = AredItems.length;
  return AredItemsCount;
}

setInterval(AredItemsCount, 1000)

const AyellowItemsCount = () => {
  const AyellowItems = tableStore.tables.filter(
    (item) => item.status === "yellow" && item.type === "A"
  );
  const AyellowItemsCount = AyellowItems.length;
  return AyellowItemsCount;
}

setInterval(AyellowItemsCount, 1000)

const AgreenItemsCount = () => {
  const AgreenItems = tableStore.tables.filter(
    (item) => item.status === "green" && item.type === "A"
  );
  const AgreenItemsCount = AgreenItems.length;
  return AgreenItemsCount;
}

setInterval(AgreenItemsCount, 1000)

const BredItemsCount = () => {
  const BredItems = tableStore.tables.filter(
    (item) => item.status === "red" && item.type === "B"
  );
  const BredItemsCount = BredItems.length;
  return BredItemsCount;
}

setInterval(BredItemsCount, 1000)

const ByellowItemsCount = () => {
  const ByellowItems = tableStore.tables.filter(
    (item) => item.status === "yellow" && item.type === "B"
  );
  const ByellowItemsCount = ByellowItems.length;
  return ByellowItemsCount;
}

setInterval(ByellowItemsCount, 1000)

const BgreenItemsCount = () => {
  const BgreenItems = tableStore.tables.filter(
    (item) => item.status === "green" && item.type === "B"
  );
  const BgreenItemsCount = BgreenItems.length;
  return BgreenItemsCount;
}

setInterval(BgreenItemsCount, 1000)

const CredItemsCount = () => {
  const CredItems = tableStore.tables.filter(
    (item) => item.status === "red" && item.type === "C"
  );
  const CredItemsCount = CredItems.length;
  return CredItemsCount;
}

setInterval(CredItemsCount, 1000)

const CyellowItemsCount = () => {
  const CyellowItems = tableStore.tables.filter(
    (item) => item.status === "yellow" && item.type === "C"
  );
  const CyellowItemsCount = CyellowItems.length;
  return CyellowItemsCount;
}

setInterval(CyellowItemsCount, 1000)

const CgreenItemsCount = () => {
  const CgreenItems = tableStore.tables.filter(
    (item) => item.status === "green" && item.type === "C"
  );
  const CgreenItemsCount = CgreenItems.length;
  return CgreenItemsCount;
}

setInterval(CgreenItemsCount, 1000)

const DredItemsCount = () => {
  const DredItems = tableStore.tables.filter(
    (item) => item.status === "red" && item.type === "D"
  );
  const DredItemsCount = DredItems.length;
  return DredItemsCount;
}

setInterval(DredItemsCount, 1000)

const DyellowItemsCount = () => {
  const DyellowItems = tableStore.tables.filter(
    (item) => item.status === "yellow" && item.type === "D"
  );
  const DyellowItemsCount = DyellowItems.length;
  return DyellowItemsCount;
}

setInterval(DyellowItemsCount, 1000)

const DgreenItemsCount = () => {
  const DgreenItems = tableStore.tables.filter(
    (item) => item.status === "green" && item.type === "D"
  );
  const DgreenItemsCount = DgreenItems.length;
  return DgreenItemsCount;
}

setInterval(DgreenItemsCount, 1000)
setInterval(tableStore.getTable, 1000);
</script>

<template>
  <v-container>
    <v-row class="justify-center">
      <v-card class="ma-5" width="1300px" color="#EEF2E6" style="height: 100%; padding-bottom: 30px;">
        <v-row class="justify-center">
          <v-card class="pa-5 ma-2 text-h4 text-center" width="1300px" color="#1C6758" style="color: white"><label>
              สถานะโต๊ะ </label>
          </v-card>
        </v-row>
        <v-row class="justify-center">
          <v-card class="textfont pa-2 ma-2" outlined>จำนวนที่นั่ง: 2 </v-card>
          <v-icon icon="mdi-checkbox-blank-circle" class="ma-4" color="#FF4A4A"></v-icon>
          <label class="count pa-2 ma-2">{{ AredItemsCount() }}</label>
          <v-icon icon="mdi-checkbox-blank-circle" class="ma-4" color="#EFF669"></v-icon>
          <label class="count pa-2 ma-2">{{ AyellowItemsCount() }}</label>
          <v-icon icon="mdi-checkbox-blank-circle" class="ma-4" color="#9BCB3C"></v-icon>
          <label class="count pa-2 ma-2">{{ AgreenItemsCount() }}</label>
        </v-row>

        <v-row class="justify-center">
          <v-col cols="13" md="0" v-for="item of tableStore.tables" :key="item.id">
          <v-card class="ma-3 d-flex justify-center" height="200px" width="200px" v-bind:style="{
            backgroundColor:
              item.status === 'red'
                ? '#FF4A4A'
                : item.status === 'yellow'
                  ? '#EFF669'
                  : '#9BCB3C',
          }" v-if="item.type === 'A'" @click="Add(item)">
            <v-card-title class="d-flex align-center justify-center text-h2">
              <label>{{ item.type }}{{ item.Number }}</label>
            </v-card-title>
          </v-card>
        </v-col>
      </v-row>
      <v-row class="justify-center">
        <v-card class="textfont pa-2 ma-2" md="0" outlined>จำนวนที่นั่ง: 4</v-card>
        <v-icon icon="mdi-checkbox-blank-circle" class="ma-4" color="#FF4A4A"></v-icon>
          <label class="count pa-2 ma-2">{{ BredItemsCount() }}</label>
          <v-icon icon="mdi-checkbox-blank-circle" class="ma-4" color="#EFF669"></v-icon>
          <label class="count pa-2 ma-2">{{ ByellowItemsCount() }}</label>
          <v-icon icon="mdi-checkbox-blank-circle" class="ma-4" color="#9BCB3C"></v-icon>
          <label class="count pa-2 ma-2">{{ BgreenItemsCount() }}</label>
        </v-row>
        <v-row class="justify-center">
          <v-col cols="13" md="0" v-for="item of tableStore.tables" :key="item.id">
            <v-card height="200px" width="200px" class="ma-3 d-flex align-center justify-center text-h4"
              v-if="item.type === 'B'" v-bind:style="{
                backgroundColor:
                  item.status === 'red'
                    ? '#FF4A4A'
                    : item.status === 'yellow'
                      ? '#EFF669'
                      : '#9BCB3C',
              }" @click="Add(item)">
              <v-card-title class="d-flex align-center justify-center text-h2">
                <label class="textfont">{{ item.type }}{{ item.Number }}</label>
              </v-card-title>
            </v-card>
          </v-col>
        </v-row>
        <v-row class="justify-center">
          <v-card class="textfont pa-2 ma-2" outlined>จำนวนที่นั่ง: 6</v-card>
          <v-icon icon="mdi-checkbox-blank-circle" class="ma-4" color="#FF4A4A"></v-icon>
          <label class="count pa-2 ma-2">{{ CredItemsCount() }}</label>
          <v-icon icon="mdi-checkbox-blank-circle" class="ma-4" color="#EFF669"></v-icon>
          <label class="count pa-2 ma-2">{{ CyellowItemsCount() }}</label>
          <v-icon icon="mdi-checkbox-blank-circle" class="ma-4" color="#9BCB3C"></v-icon>
          <label class="count pa-2 ma-2">{{ CgreenItemsCount() }}</label>
        </v-row>
        <v-row class="justify-center">
          <v-col cols="13" md="0" v-for="item of tableStore.tables" :key="item.id">
            <v-card height="200px" width="200px" class="ma-3 d-flex align-center justify-center text-h4"
              v-if="item.type === 'C'" v-bind:style="{
                backgroundColor:
                  item.status === 'red'
                    ? '#FF4A4A'
                    : item.status === 'yellow'
                      ? '#EFF669'
                      : '#9BCB3C',
              }" @click="Add(item)">
              <v-card-title class="d-flex align-center justify-center text-h2">
                <label class="textfont">{{ item.type }}{{ item.Number }}</label>
              </v-card-title>
            </v-card>
          </v-col>
        </v-row>
        <v-row class="justify-center">
          <v-card class="textfont pa-2 ma-2" outlined>จำนวนที่นั่ง: 8</v-card>
          <v-icon icon="mdi-checkbox-blank-circle" class="ma-4" color="#FF4A4A"></v-icon>
          <label class="count pa-2 ma-2">{{ DredItemsCount() }}</label>
          <v-icon icon="mdi-checkbox-blank-circle" class="ma-4" color="#EFF669"></v-icon>
          <label class="count pa-2 ma-2">{{ DyellowItemsCount() }}</label>
          <v-icon icon="mdi-checkbox-blank-circle" class="ma-4" color="#9BCB3C"></v-icon>
          <label class="count pa-2 ma-2">{{ DgreenItemsCount() }}</label>
        </v-row>
        <v-row class="justify-center">
          <v-col cols="13" md="0" v-for="item of tableStore.tables" :key="item.id">
            <v-card height="200px" width="200px" class="ma-3 d-flex align-center justify-center text-h4"
              v-if="item.type === 'D'" v-bind:style="{
                backgroundColor:
                  item.status === 'red'
                    ? '#FF4A4A'
                    : item.status === 'yellow'
                      ? '#EFF669'
                      : '#9BCB3C',
              }" @click="Add(item)">
              <v-card-title class="d-flex align-center justify-center text-h2">
                <label class="textfont">{{ item.type }}{{ item.Number }}</label>
              </v-card-title>
            </v-card>
          </v-col>
        </v-row>
        <v-navigation-drawer v-model="drawerg" location="right" style="width: 500px; background-color: #EEF2E6;" app
          temporary height="100%">
          <v-card style="padding-bottom: 20px; background-color: transparent">
            <v-card-title class="d-flex align-center justify-center ma-6">
              <span class="text-h2"><label>{{ tableStore.ItemDialog.type }}{{ tableStore.ItemDialog.Number
              }}</label></span>
            </v-card-title>
            <!-- <v-img
                  height="300"
                  weight="300"
                  src="qrCodeUrl"
                ></v-img> -->
            <!-- <qrcode :value="qrCodeUrl" /> -->

            <v-card-text class="d-flex align-center justify-center text-h4">
              <label class="seat">สถานะ:</label>
              <label class="colorg">ว่าง</label>
            </v-card-text>
            <v-card-text class="d-flex align-center justify-center text-h4">
              <label class="seat">จำนวนที่นั่ง:</label>
              <p v-if="tableStore.ItemDialog.type === 'A'">&nbsp;2</p>
              <p v-if="tableStore.ItemDialog.type === 'B'">&nbsp;4</p>
              <p v-if="tableStore.ItemDialog.type === 'C'">&nbsp;6</p>
              <p v-if="tableStore.ItemDialog.type === 'D'">&nbsp;8</p>
            </v-card-text>
            <v-card-actions class="justify-center">
              <v-btn style="background-color: #81b214" size="x-large" @click="Open"><label
                  class="open">Open</label></v-btn>
            </v-card-actions>
          </v-card>
        </v-navigation-drawer>
        <!-- สีแดง -->
        <v-navigation-drawer v-model="drawer" location="right" style="width: 500px; background-color: #EEF2E6;" app
          temporary height="100%">
          <v-card style="padding-bottom: 20px;  overflow-y: scroll;background-color: transparent" height="100%">
            <v-card-title class="d-flex align-center justify-center ma-6">
              <span class="text-h2"><label>{{ tableStore.ItemDialog.type
              }}{{ tableStore.ItemDialog.Number }}</label></span>
            </v-card-title>
            <v-card-text class="d-flex align-center justify-center text-h4" height="100%">
              <vue-qrcode class="vue-qrcode" :value="tableStore.qrCodeUrl" v-if="showQR" type="image/png"
                :color="{ dark: '#000000FF', light: '#FFFFFFFF' }" />
            </v-card-text>
            <v-card-text class="d-flex align-center justify-center text-h4"><label class="seat">สถานะ: </label><label
                class="colorr">ไม่ว่าง</label>
            </v-card-text>
            <v-card-text class="d-flex align-center justify-center text-h4">
              <label class="seat">จำนวนที่นั่ง:</label>
              <p v-if="tableStore.ItemDialog.type === 'A'">&nbsp;2</p>
              <p v-if="tableStore.ItemDialog.type === 'B'">&nbsp;4</p>
              <p v-if="tableStore.ItemDialog.type === 'C'">&nbsp;6</p>
              <p v-if="tableStore.ItemDialog.type === 'D'">&nbsp;8</p>
            </v-card-text>
            <v-card-actions class="justify-center">
              <v-btn size="x-large" style="background-color: #FFC000" @click="show = !show"><label
                  class="pay">Change</label></v-btn>
            </v-card-actions>
            <div v-show="show">
              <v-divider></v-divider>

              <v-row class="justify-center pa-5">
                <v-card class="ma-5" height="200px" width="400px" color="#EEF2E6" style="overflow-y: scroll">
                  <v-row class="justify-center pa-5">
                    <v-col cols="13" md="0" v-for="item of tableStore.tables" :key="item.id">
                      <v-card class="ma-3 d-flex justify-center" height="50px" width="50px" color="#9BCB3C"
                        v-if="item.status === 'green'" @click="Change(item)">
                        <v-card-title class="d-flex align-center justify-center text-h6"><label class="showtable">{{
                          item.type }}{{ item.Number }}</label>
                        </v-card-title>
                      </v-card>
                    </v-col>
                  </v-row>
                </v-card>
                <!-- <div v-show="showConfirm"> -->
                <v-card-title class="d-flex align-center justify-center ma-6">
                  <span class="text-h4"><label style="color: #ff4a4a">{{ tableStore.ItemDialog.type
                  }}{{ tableStore.ItemDialog.Number }} </label><label style="padding: 10px">≫</label><label
                      style="color: #81b214" v-if="tableStore.ItemChangeTable.Number != 0">
                      {{ tableStore.ItemChangeTable.type
                      }}{{ tableStore.ItemChangeTable.Number }}</label></span>
                </v-card-title>
                <!-- <div v-show="showConfirm"> -->
                  <v-card-actions v-show="showConfirm" class="justify-center">

                    <v-btn size="x-large" style="background-color: #8FAADC" @click="confirmChangeTable"><label
                        class="pay">Confirm</label></v-btn>

                  </v-card-actions>
                <!-- </div> -->
              </v-row>
            </div>
          </v-card>
          <!-- <v-divider></v-divider>
          <v-col cols="12"> -->
            <!-- <v-table>
                  <thead>
                    <tr>
                      <th>จำนวน</th>
                      <th>ชื่อ</th>
                      <th>ราคา(บาท)</th>
                      <th>ราคารวม(บาท)</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr v-for="item of paymentStore.OrderPay" :key="item.id">
                      <td>{{ item.num }}</td>
                      <td>{{ item.name }}</td>
                      <td>{{ item.price }}</td>
                      <td>{{ item.price }}</td>
                    </tr>
                  </tbody>
                </v-table> -->
          <!-- </v-col>
          <v-divider></v-divider> -->
        </v-navigation-drawer>
        <!-- สีเหลือง -->
        <v-navigation-drawer v-model="drawery" location="right" style="width: 500px; background-color: #EEF2E6;" app
          temporary height="100%">
          <v-card style="padding-bottom: 20px; background-color: transparent">
            <v-card-title class="d-flex align-center justify-center ma-6">
              <span class="text-h2"><label>{{ tableStore.ItemDialog.type
              }}{{ tableStore.ItemDialog.Number }}</label></span>
            </v-card-title>
            <v-card-text class="d-flex align-center justify-center text-h4"><label class="seat">สถานะ: </label><label
                class="color">รอทำความสะอาด</label>
            </v-card-text>
            <v-card-text class="d-flex align-center justify-center text-h4">
              <label class="seat">จำนวนที่นั่ง:</label>
              <p v-if="tableStore.ItemDialog.type === 'A'">&nbsp;2</p>
              <p v-if="tableStore.ItemDialog.type === 'B'">&nbsp;4</p>
              <p v-if="tableStore.ItemDialog.type === 'C'">&nbsp;6</p>
              <p v-if="tableStore.ItemDialog.type === 'D'">&nbsp;8</p>
            </v-card-text>
          </v-card>
        </v-navigation-drawer>
      </v-card>
    </v-row>
  </v-container>
</template>


<style scoped>
@import url("https://fonts.googleapis.com/css2?family=Noto+Sans+Thai:wght@100&display=swap");

.textfont {
  font-family: "Noto Sans Thai", sans-serif;
  font-weight: bold;
}

.count {
  font-size: 16px !important;
  color: black;
}

label {
  font-family: "Noto Sans Thai", sans-serif;
  font-weight: bold;
  font-size: 48px !important;
}

.main {
  font-size: 48px !important;
}

.seat,
p {
  font-family: "Noto Sans Thai", sans-serif;
  font-weight: bold;
  font-size: 24px !important;
}

.clean {
  font-size: 20px !important;
  color: black;
}

.color {
  font-size: 24px !important;
  color: #ffb100;
  padding-left: 10px;
}

.pay {
  font-size: 20px !important;
  color: black;
}

.colorr {
  font-size: 24px !important;
  color: #ff4a4a;
  padding-left: 10px;
}

th,
td {
  font-family: "Noto Sans Thai", sans-serif;
  font-weight: bold;
  font-size: 15px !important;
}

.colorg {
  font-size: 24px !important;
  color: #81b214;
  padding-left: 10px;
}

.open {
  font-size: 20px !important;
  color: black;
}

.showtable {
  font-size: 15px !important;
}

.vue-qrcode {
  width: 250px;
  height: 250px;
}
</style>